This service will be undergoing maintenance at 00:00 UTC, 2016-08-01. It is expected to last about 1 hours
Bug 517144 - Review Request: ghc-HUnit - unit testing support for Haskell
Review Request: ghc-HUnit - unit testing support for Haskell
Status: CLOSED NEXTRELEASE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Yaakov Nemoy
Fedora Extras Quality Assurance
: Reopened
Depends On:
Blocks: haskell-platform
  Show dependency treegraph
 
Reported: 2009-08-12 14:22 EDT by Bryan O'Sullivan
Modified: 2010-10-05 09:22 EDT (History)
5 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-08-31 23:20:53 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
loupgaroublond: fedora‑review+
tibbs: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Bryan O'Sullivan 2009-08-12 14:22:24 EDT
Spec: http://www.serpentine.com/bos/files/ghc-HUnit.spec
SRPM: http://www.serpentine.com/bos/files/ghc-HUnit-1.2.0.3-1.fc11.src.rpm
Description:
This package provides the Haskell HUnit library for ghc.  HUnit
is a unit testing framework for Haskell, inspired by the JUnit tool
for Java.
Comment 1 Yaakov Nemoy 2009-08-25 11:25:09 EDT
MUST: rpmlint must be run on every package. The output should be posted in the review.[1]
[yankee@koan ghc-HUnit]$ rpmlint -iv *{spec,rpm}
ghc-HUnit.src: I: checking                      
ghc-HUnit-devel.i586: I: checking               
ghc-HUnit-devel.ppc: I: checking                
ghc-HUnit-devel.x86_64: I: checking             
ghc-HUnit-doc.i586: I: checking                 
ghc-HUnit-doc.i586: E: description-line-too-long This package contains development documentation files for the ghc-HUnit library.                                                                                             
Your description lines must not exceed 79 characters. If a line is exceeding                                   
this number, cut it to fit in two lines.                                                                       

ghc-HUnit-doc.ppc: I: checking
ghc-HUnit-doc.ppc: E: description-line-too-long This package contains development documentation files for the ghc-HUnit library.                                                                                              
Your description lines must not exceed 79 characters. If a line is exceeding                                   
this number, cut it to fit in two lines.                                                                       

ghc-HUnit-doc.x86_64: I: checking
ghc-HUnit-doc.x86_64: E: description-line-too-long This package contains development documentation files for the ghc-HUnit library.                                                                                           
Your description lines must not exceed 79 characters. If a line is exceeding                                   
this number, cut it to fit in two lines.                                                                       

ghc-HUnit-prof.i586: I: checking
ghc-HUnit-prof.i586: E: devel-dependency ghc-HUnit-devel
Your package has a dependency on a devel package but it's not a devel package
itself.                                                                      

ghc-HUnit-prof.i586: W: no-documentation
The package contains no documentation (README, doc, etc). You have to include
documentation files.                                                         

ghc-HUnit-prof.i586: W: devel-file-in-non-devel-package /usr/lib/ghc-6.10.3/HUnit-1.2.0.3/libHSHUnit-1.2.0.3_p.a                                                                                                              
A development file (usually source code) is located in a non-devel package. If                                 
you want to include source code in your package, be sure to create a                                           
development package.                                                                                           

ghc-HUnit-prof.ppc: I: checking
ghc-HUnit-prof.ppc: E: devel-dependency ghc-HUnit-devel
Your package has a dependency on a devel package but it's not a devel package
itself.                                                                      

ghc-HUnit-prof.ppc: W: no-documentation
The package contains no documentation (README, doc, etc). You have to include
documentation files.                                                         

ghc-HUnit-prof.ppc: W: devel-file-in-non-devel-package /usr/lib/ghc-6.10.3/HUnit-1.2.0.3/libHSHUnit-1.2.0.3_p.a
A development file (usually source code) is located in a non-devel package. If                                 
you want to include source code in your package, be sure to create a                                           
development package.                                                                                           

ghc-HUnit-prof.x86_64: I: checking
ghc-HUnit-prof.x86_64: E: devel-dependency ghc-HUnit-devel
Your package has a dependency on a devel package but it's not a devel package
itself.

ghc-HUnit-prof.x86_64: W: no-documentation
The package contains no documentation (README, doc, etc). You have to include
documentation files.

ghc-HUnit-prof.x86_64: W: devel-file-in-non-devel-package /usr/lib64/ghc-6.10.3/HUnit-1.2.0.3/libHSHUnit-1.2.0.3_p.a
A development file (usually source code) is located in a non-devel package. If
you want to include source code in your package, be sure to create a
development package.

10 packages and 1 specfiles checked; 6 errors, 6 warnings.

>>> CHECK -> normal for haskell packages, with the exception of the description warning. Please fix it.



MUST: The package must be named according to the Package Naming Guidelines .
>>> CHECK

MUST: The spec file name must match the base package %{name}, in the format %{name}.spec unless your package has an exemption. [2] .
>>> CHECK

MUST: The package must meet the Packaging Guidelines .
>>> CHECK

MUST: The package must be licensed with a Fedora approved license and meet the Licensing Guidelines .
>>> CHECK

MUST: The License field in the package spec file must match the actual license. [3]
>>> CHECK

MUST: If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package must be included in %doc.[4]
>>> CHECK

MUST: The spec file must be written in American English. [5]
>>> CHECK

MUST: The spec file for the package MUST be legible. [6]
>>> CHECK

MUST: The sources used to build the package must match the upstream source, as provided in the spec URL. Reviewers should use md5sum for this task. If no upstream URL can be specified for this package, please see the Source URL Guidelines for how to deal with this.
>>> CHECK -> Presuming innocence here re: using the official tarballfor the Platform project.

MUST: The package MUST successfully compile and build into binary rpms on at least one primary architecture. [7]
>>> CHECK

MUST: If the package does not successfully compile, build or work on an architecture, then those architectures should be listed in the spec in ExcludeArch. Each architecture listed in ExcludeArch MUST have a bug filed in bugzilla, describing the reason that the package does not compile/build/work on that architecture. The bug number MUST be placed in a comment, next to the corresponding ExcludeArch line. [8]
>>> CHECK

MUST: All build dependencies must be listed in BuildRequires, except for any that are listed in the exceptions section of the Packaging Guidelines ; inclusion of those as BuildRequires is optional. Apply common sense.
>>> CHECK

MUST: A package must own all directories that it creates. If it does not create a directory that it uses, then it should require a package which does create that directory. [12]
>>> CHECK

MUST: A Fedora package must not list a file more than once in the spec file's %files listings. [13]
>>> CHECK

MUST: Permissions on files must be set properly. Executables should be set with executable permissions, for example. Every %files section must include a %defattr(...) line. [14]
>>> CHECK

MUST: Each package must have a %clean section, which contains rm -rf %{buildroot} (or $RPM_BUILD_ROOT). [15]
>>> CHECK

MUST: Each package must consistently use macros. [16]
>>> CHECK

MUST: The package must contain code, or permissable content. [17]
>>> CHECK

MUST: Large documentation files must go in a -doc subpackage. (The definition of large is left up to the packager's best judgement, but is not restricted to size. Large can refer to either size or quantity). [18]
>>> CHECK

MUST: If a package includes something as %doc, it must not affect the runtime of the application. To summarize: If it is in %doc, the program must run properly if it is not present. [18]
>>> CHECK

MUST: In the vast majority of cases, devel packages must require the base package using a fully versioned dependency: Requires: %{name} = %{version}-%{release} [22]
>>> CHECK

MUST: Packages must not own files or directories already owned by other packages. The rule of thumb here is that the first package to be installed should own the files or directories that other packages may rely upon. This means, for example, that no package in Fedora should ever share ownership with any of the files or directories owned by the filesystem or man package. If you feel that you have a good reason to own a file or directory that another package owns, then please present that at package review time. [24]
>>> CHECK

MUST: At the beginning of %install, each package MUST run rm -rf %{buildroot} (or $RPM_BUILD_ROOT). [25]
>>> CHECK

MUST: All filenames in rpm packages must be valid UTF-8. [26]
>>> CHECK

SHOULD Items:
Items marked as SHOULD are things that the package (or reviewer) SHOULD do, but is not required to do.

SHOULD: If the source package does not include license text(s) as a separate file from upstream, the packager SHOULD query upstream to include it. [27]
>>> CHECK

SHOULD: The reviewer should test that the package builds in mock. [29]
>>> CHECK

SHOULD: The package should compile and build into binary rpms on all supported architectures. [30]
>>> CHECK

SHOULD: The reviewer should test that the package functions as described. A package should not segfault instead of running, for example.
>>> CHECK

SHOULD: Usually, subpackages other than devel should require the base package using a fully versioned dependency. [22]
>>> CHECK

SHOULD: If the package has file dependencies outside of /etc, /bin, /sbin, /usr/bin, or /usr/sbin consider requiring the package which provides the file instead of the file itself. [32] 
>>> CHECK

Resolution: PASS, please fix the description
Comment 2 Bryan O'Sullivan 2009-08-26 00:28:30 EDT
Will do, thanks.
Comment 3 Bryan O'Sullivan 2009-08-26 00:29:20 EDT
New Package CVS Request
=======================
Package Name: ghc-HUnit
Short Description: unit testing support for Haskell
Owners: bos ynemoy petersen
Branches: F-11 F-12
InitialCC: haskell-sig
Comment 4 Kevin Fenzi 2009-08-26 18:19:31 EDT
we are not doing F-12 branches yet. 
Otherwise cvs done.
Comment 5 Fedora Update System 2009-08-27 15:49:19 EDT
ghc-HUnit-1.2.0.3-1.fc11 has been submitted as an update for Fedora 11.
http://admin.fedoraproject.org/updates/ghc-HUnit-1.2.0.3-1.fc11
Comment 6 Jens Petersen 2009-08-31 05:55:59 EDT
(In reply to comment #1)
> MUST: The sources used to build the package must match the upstream source, as
> provided in the spec URL. Reviewers should use md5sum for this task. If no
> upstream URL can be specified for this package, please see the Source URL
> Guidelines for how to deal with this.
> >>> CHECK -> Presuming innocence here re: using the official tarballfor the Platform project.

I didn't understand this comment: the reference src tarball is from hackage.

> MUST: Packages must not own files or directories already owned by other
> packages. The rule of thumb here is that the first package to be installed
> should own the files or directories that other packages may rely upon. This
> means, for example, that no package in Fedora should ever share ownership with
> any of the files or directories owned by the filesystem or man package. If you
> feel that you have a good reason to own a file or directory that another
> package owns, then please present that at package review time. [24]
> >>> CHECK

> SHOULD: The reviewer should test that the package functions as described. A
> package should not segfault instead of running, for example.
> >>> CHECK

Errm, HUnit is already in ghc....

So do we remove HUnit from ghc or drop this package for now?

Looks like a typo in haskell-platform.cabal to me?
Or am I totally confused?
Comment 7 Jens Petersen 2009-08-31 06:02:45 EDT
> Looks like a typo in haskell-platform.cabal to me?

Correctly it is part of ghc-src-extralibs, which haskell-platform
will replace of course.

Anyway we don't need this until we drop extras from ghc.
Comment 8 Yaakov Nemoy 2009-08-31 06:14:18 EDT
Are they the same version? Personally, i'd rather deliver as many libraries via subpackages anyways.
Comment 9 Yaakov Nemoy 2009-08-31 06:17:03 EDT
Is the tarball from hackage then? Some of the tarballs Bryan used came from the platform tarball and for some reason did not checksum properly. It was the only problem we found, and for the matter of speed, i let it slide, as the reviewer.
Comment 10 Bryan O'Sullivan 2009-08-31 13:04:26 EDT
GHC 6.12 will be out within a matter of weeks (beta is scheduled for September 14), and won't include any extralibs, so let's just leave this as is. We'll be wanting to upgrade within the early lifetime of F-12.
Comment 11 Jens Petersen 2009-08-31 23:20:53 EDT
Anyway thanks for picking up the haskell-platform -
I hadn't been following and it is starting to make sense now.

(In reply to comment #8)
> Are they the same version?

Good question - sure we need to keep the package in sync with haskell-platform.

> Personally, i'd rather deliver as many libraries via
> subpackages anyways.  

Hmm, well I thought about this too - weighing the effort of
separate packages with the complexity of haskell-platform subpackages.
Anyway we seems to have started going down the separate package
path which which should be good and fine as long as we are
careful to preserve version: I'll add a comment about haskell-platform
in the spec file and suggest we do the same for all packages
that form a part of Platform.

(In reply to comment #9)
> Is the tarball from hackage then? Some of the tarballs Bryan used came from the
> platform tarball and for some reason did not checksum properly. It was the only
> problem we found, and for the matter of speed, i let it slide, as the reviewer.  

That is a no-no really - either we use the hackage packages or
the haskell-platform tarball I don't think we should mix them
- presumably all haskell-platform packages are available as
separate tarballs since haskell-platform also is distributed
without them.
Comment 12 Jens Petersen 2009-08-31 23:25:31 EDT
(In reply to comment #9)
> Is the tarball from hackage then?

Anyway yes it is: I just checked - please do so next time:
I usually include the md5sum in the review.

948b5b20ff22fa81c6390b08d6af5104  HUnit-1.2.0.3.tar.gz
Comment 13 Bryan O'Sullivan 2009-09-01 12:50:38 EDT
Once I figured out that the checksums were different, I rolled the real RPMs that are now in rawhide from the original packages on hackage, not the platform tarball. So this won't arise again.
Comment 14 Jens Petersen 2009-09-01 20:14:43 EDT
Thanks, Bryan :)

I still feel like it is going to be hard to keep all the separate
packages in sync and avoid accidental version bumps, etc and wonder
if packaging the full haskell-platform package might not be
easier maintenance-wise?  We are still missing a lot of extralibs
and platform packages anyway in Fedora.

(This might be going over ground we already covered,
but just wonder how you feel on it having started the separate
packaging?)
Comment 15 Jens Petersen 2010-10-05 00:58:20 EDT
Package Change Request
======================
Package Name: ghc-HUnit
New Branches: el6
Owners: bos petersen
InitialCC: haskell-sig
Comment 16 Jason Tibbitts 2010-10-05 09:22:39 EDT
Git done (by process-git-requests).

Note You need to log in before you can comment on or make changes to this bug.